#include <bits/stdc++.h>

using namespace std;

void add(vector<int>& tree, int k, int val) {
    k++;
    while(k <= tree.size()) {
        tree[k-1] += val;
        k += k & -k;
    }
}

void binary_indexed_tree(const vector<int>& array, vector<int>& tree) {
    tree.resize(array.size());
    for(int i = 0; i < array.size(); i++) add(tree, i, array[i]);
}

int sumq(const vector<int>& tree, int k) {
    k++;
    int res = 0;
    while(k >= 1) {
        res += tree[k-1];
        k -= k & -k;
    }
    return res;
}

int sumq(const vector<int>& tree, int a, int b) {
    return sumq(tree, b) - sumq(tree, a - 1);
}

int main() {
    vector<int> array = {1, 3, 4, 8, 6, 1, 4, 2};
    
    vector<int> tree;
    binary_indexed_tree(array, tree);
    
    cout << sumq(tree, 3, 6) << endl;
    
    return 0;
}

