#include <bits/stdc++.h>

using namespace std;

void difference_array(const vector<int>& array, vector<int>& diff) {
    diff.resize(array.size());
    diff[0] = array[0];
    for(int i = 1; i < array.size(); i++) diff[i] = array[i] - array[i-1];
}

void add(vector<int>& diff, int a, int b, int val) {
    diff[a] += val;
    if(b+1 < diff.size()) diff[b+1] -= val;
}

int get_value(vector<int>& diff, int idx) {
    int res = 0;
    for(int i = 0; i <= idx; i++) res += diff[i];
    return res;
}

int main() {
    vector<int> diff;
    difference_array({3, 3, 1, 1, 1, 5, 2, 2}, diff);

    for(auto x : diff) cout << x << " ";
    cout << endl;
    for(int i = 0; i < diff.size(); i++) cout << get_value(diff, i) << " ";
    cout << endl;
    
    add(diff, 1, 4, 5);
    
    for(auto x : diff) cout << x << " ";
    cout << endl;
    for(int i = 0; i < diff.size(); i++) cout << get_value(diff, i) << " ";
    cout << endl;

    return 0;
}
