#include <bits/stdc++.h>

using namespace std;

void prefix_sum_array(const vector<int>& array, vector<int>& prefix) {
    if(array.empty()) return;
    prefix.push_back(array[0]);
    for(int i = 1; i < array.size(); i++) prefix.push_back(prefix.back() + array[i]);
}

int sumq(const vector<int>& prefix, int a, int b) {
    return prefix[b] - (a > 0 ? prefix[a-1] : 0);
}

int main() {
    vector<int> array = {1, 3, 4, 8, 6, 1, 4, 2};
    
    vector<int> prefix;
    prefix_sum_array(array, prefix);
    
    cout << sumq(prefix, 3, 6) << endl;
    
    return 0;
}

